moDraw.bestprice = {};

function moDraw.bestprice:setOpenPdaSlot(self, slot, slotName)	
	if moFillTypes == nil or moFillTypes[1] == nil then
		moGuiExtras:closeOpenSlot(self, slot, true, false);
		g_currentMission:showBlinkingWarning(tostring(moLanguageXml:getTxt("slotno")), 2500);
		return;
	end;
	----
	--if moGuiMiniPdaSlots.values[slot].permUpdate then MultiOverlayV2:setSlotUpdate(self, slot);end;
	--moGuiExtras:setSlotMaxProSwitch(self, slot);
	--moGuiExtras:setSlotFirstEndObjects(self, slot);
	--local firstObjectDisplay, endObjectDisplay = moGuiMiniPdaSlots.values[slot].firstObject, moGuiMiniPdaSlots.values[slot].endObject;
	--local tempObjectDisplay = 0;
	----
	local farmSilo = moGeneralSettings.multiFarmSilo;
	local hotSpot = moGuiMiniPdaSlots.values[slot].hotSpot;
	if hotSpot then moGuiMiniPdaSlots.values[slot].clickArea.slotHotSpot = {};end;
	local posX = moGuiMiniPdaSlots.values[slot].openX+0.001;
	local posY = moGuiMiniPdaSlots.values[slot].openY;
	local size = moGuiMiniPdaSlots.values[slot].size;
	local distanceLine = moGuiMiniPdaSlots.values[slot].distanceLine;
	local widthSettings = moSetGetGui.buttonGfxWidth1*moSetGetGui.zoomOutInTemp*4;
	local heightSettings = moSetGetGui.buttonGfxHeight1*moSetGetGui.zoomOutInTemp*4;	
	local height = moSetGetGui.buttonGfxHeight1*(size*1000);
	local heightDefault = moSetGetGui.buttonGfxHeight1*(size*1000);
	local distanceDif = moGuiMiniPdaSlots.values[slot].distanceDif; --fillcontainer <----> filllevel
	local slotLength = moSetGetGui.buttonGfxWidth1*(size*1000/1.5)*(moGuiMiniPdaSlots.values[slot].length+moSetGetGui.screenAspectRatio);	
	local width = slotLength+distanceDif;	
	local widthNext = moSetGetGui.buttonGfxWidth1*(size*1000/1.5)*(moGeneralSettings.lengthStationName+moSetGetGui.screenAspectRatio);
	local currentPosY = posY;
	function nextLine(setHeight, posYnew, setLine, posYline, widthLine, heightLine, onlyLine)
		if setLine then
			moSetGetGui:setOverlay(self, moSetGetGui["designLine"], posX-0.001, currentPosY-(posYline), widthLine, heightLine);
			moSetGetGui["designLine"]:render();
			if onlyLine then return;end;
		end;		
		if setHeight then height = height+(heightDefault)+posYnew;end; --height+size+posNew;
		currentPosY = currentPosY-(heightDefault)-posYnew; --posY-(size+posYnew);		
	end;	
	moSetGetGui["designGround".. slot]:render();
	setTextBold(true);	
	setTextColor(unpack(moGuiMiniPdaSlots.siloColor));
	local sizeTemp = 0.010;
	if size < sizeTemp then sizeTemp = size;end;
	if moGuiMiniPdaSlots.keySwitchLast == slot then
		if not moGuiMiniPdaSlots.values[slot].settings then
			moSetGetGui["slotCfg"]:setPosition(posX, posY);
			moSetGetGui["slotCfg"]:render();
		else
			moSetGetGui["slotPos"]:setPosition(posX, posY);
			moSetGetGui["slotPos"]:render();
		end;
		nextLine(true, 0.005, false);
		moSetGetGui["slotFruit"]:setPosition(posX+(widthSettings*1), posY);
		moSetGetGui["slotFruit"]:render();		
		if not moGuiMiniPdaSlots.values[slot].seeInOutFruit then
			moSetGetGui["slotNotOkay"]:setPosition(posX+(widthSettings*1), posY);
			moSetGetGui["slotNotOkay"]:render();
		end;
		moSetGetGui["slotMoney"]:setPosition(posX+(widthSettings*2), posY);
		moSetGetGui["slotMoney"]:render();		
		if not moGuiMiniPdaSlots.values[slot].seePrice then
			moSetGetGui["slotNotOkay"]:setPosition(posX+(widthSettings*2), posY);
			moSetGetGui["slotNotOkay"]:render();
		end;
		moSetGetGui["slotPlus"]:setPosition(posX+(widthSettings*3), posY);
		moSetGetGui["slotPlus"]:render();		
		if moGuiMiniPdaSlots.values[slot].seeSmall then
			moSetGetGui["slotNotOkay"]:setPosition(posX+(widthSettings*3), posY);
			moSetGetGui["slotNotOkay"]:render();
		end;
		if not moGuiMiniPdaSlots.values[slot].hotSpot then
			moSetGetGui["slotHotSpot"]:setPosition(posX, posY-(heightSettings));
			moSetGetGui["slotHotSpot"]:render();
			moSetGetGui["slotNotOkay"]:setPosition(posX, posY-(heightSettings));
			moSetGetGui["slotNotOkay"]:render();
		else
			if moGuiMiniPdaSlots.isHotSpotObj then
				if moGuiMiniPdaSlots.warningBlinkTemp <= moGuiMiniPdaSlots.warningBlinkTime then --warningBlinkTime, warningBlinkTemp
					moGuiMiniPdaSlots.warningBlinkTemp = moGuiMiniPdaSlots.warningBlinkTemp+1			
					moSetGetGui["slotHotSpot"]:setPosition(posX, posY-(heightSettings));
					moSetGetGui["slotHotSpot"]:render();			
				else
					moGuiMiniPdaSlots.warningBlinkTemp = moGuiMiniPdaSlots.warningBlinkTemp+1
					if moGuiMiniPdaSlots.warningBlinkTemp >= moGuiMiniPdaSlots.warningBlinkTime*2 then moGuiMiniPdaSlots.warningBlinkTemp = 0;end;
				end;
			else
				moSetGetGui["slotHotSpot"]:setPosition(posX, posY-(heightSettings));
				moSetGetGui["slotHotSpot"]:render();
			end;
		end;					
		moSetGetGui["slotSwitchL"]:setPosition(posX+(widthSettings*4), posY);
		moSetGetGui["slotSwitchL"]:render();
		renderText(posX+(widthSettings*4.7), posY+0.0035, sizeTemp, tostring(moGuiMiniPdaSlots.values[slot].switch));
		moSetGetGui["slotSwitchR"]:setPosition(posX+(widthSettings*5), posY);
		moSetGetGui["slotSwitchR"]:render();
		moSetGetGui["slotNextL"]:setPosition(posX+(widthSettings*6), posY);
		moSetGetGui["slotNextL"]:render();
		moSetGetGui["slotNextR"]:setPosition(posX+(widthSettings*8), posY);
		moSetGetGui["slotNextR"]:render();
		renderText(posX+(widthSettings*7.2), posY+0.0035, sizeTemp, tostring(moGuiMiniPdaSlots.values[slot].maxProSwitch));					
	else
		moSetGetGui["slotNotReady"]:setPosition(posX, posY-(heightSettings));
		moSetGetGui["slotNotReady"]:render();
		nextLine(true, 0.005, false);
		renderText(posX, posY+0.0035, sizeTemp, "Slotname:  ".. tostring(moGuiMiniPdaSlots.values[slot].name));
	end;	
	----
	renderText(posX+(widthSettings*1.1), currentPosY, size, tostring(moLanguageXml:getTxt("bestprices")).. ":");
	setTextAlignment(RenderText.ALIGN_RIGHT);
	setTextColor(unpack(moGuiMiniPdaSlots.siloColor));
	--renderText(posX+width-distanceDif, currentPosY, size, tostring(moGuiMiniPdaSlots.values[slot].foundObjects));		
	setTextAlignment(false);	
	nextLine(true, 0.007, true, 0.0035, width+widthNext, 0.001);
	----
	function setInternBestPrice(bestPrice, k)		
		local bestPriceTemp = string.format("%.1f", Utils.getNoNil(bestPrice,0));		
		setTextColor(unpack(moGuiMiniPdaSlots.activeColor));
		setTextBold(true);
		setTextAlignment(false);
		local noAmount = false;
		if moFillTypes[k].siloAmount[farmSilo] ~= nil and moFillTypes[k].siloAmount[farmSilo] <= 1 then setTextColor(unpack(moGuiMiniPdaSlots.inactiveColor));noAmount = true;setTextBold(false);end;
		if string.find(moFillTypes[k].fruitName, "!") then
			setTextColor(unpack(moGuiMiniPdaSlots.warningColor3));
			renderText(posX, currentPosY, size, "!".. moFillTypes[k].descName); ---old 0.232
		else
			renderText(posX, currentPosY, size, moFillTypes[k].fruitName);
		end;
		setTextBold(true);
		setTextAlignment(RenderText.ALIGN_RIGHT);
		setTextColor(unpack(moGuiMiniPdaSlots.priceColor));
		local greatDemand = false;
		if moGeneralSettings.foundGreatDemand > 0 and moFillTypes[k].greatDemandStation ~= nil then setTextColor(unpack(moGuiMiniPdaSlots.demandColor));greatDemand = true;end;							
		if noAmount then setTextBold(false);end;
		renderText(posX+width-distanceDif, currentPosY, size, bestPriceTemp);				
		setTextAlignment(RenderText.ALIGN_LEFT);
		setTextColor(unpack(moGuiMiniPdaSlots.activeColor));		
		if greatDemand then 
			renderText(posX+width, currentPosY, size, moFillTypes[k].greatDemandStation);
			if hotSpot then setClickAreaHotSpot(self, posX+width, currentPosY, widthNext, heightDefault, moFillTypes[k].x, moFillTypes[k].z, moFillTypes[k].greatDemandStation, slot);end;
		else
			renderText(posX+width, currentPosY, size, moFillTypes[k].bestPriceStation);
			if hotSpot then setClickAreaHotSpot(self, posX+width, currentPosY, widthNext, heightDefault, moFillTypes[k].x, moFillTypes[k].z, moFillTypes[k].bestPriceStation, slot);end;
		end;				
		nextLine(true, distanceLine, true, 0.0035, width+widthNext, 0.001);
	end;
	local bestPriceTotal = 0;
	function setInternBestPriceTotal(bestPrice, k)		
		setTextAlignment(false);
		if moGuiMiniPdaSlots.values[slot].permUpdate then local emptyFruit = moSetGetAmount:getNoFoundSiloAmount(k);end;
		local bestPriceTemp = string.format("%.1f", Utils.getNoNil(bestPrice,0));		
		setTextColor(unpack(moGuiMiniPdaSlots.activeColor));
		setTextBold(true);
		local noAmount = false;
		if moFillTypes[k].siloAmount[farmSilo] ~= nil then
			if moFillTypes[k].siloAmount[farmSilo] <= 1 then 
				setTextColor(unpack(moGuiMiniPdaSlots.inactiveColor));
				setTextBold(false);
				bestPriceTemp = string.format("%.1f", 0.0);
				noAmount = true;
			else				
				local total = bestPrice*(tonumber(moFillTypes[k].siloAmount[farmSilo]/1000))/1000;
				bestPriceTotal = bestPriceTotal+total;
				bestPriceTemp = string.format("%.3f", total);
				bestPriceTemp = moGuiExtras:getMoneyFormat(bestPriceTemp);
			end;
		end;
		if string.find(moFillTypes[k].fruitName, "!") then
			setTextColor(unpack(moGuiMiniPdaSlots.warningColor3));
			renderText(posX, currentPosY, size, "!".. moFillTypes[k].descName); ---old 0.232
		else
			renderText(posX, currentPosY, size, moFillTypes[k].fruitName);
		end;
		setTextBold(true);
		setTextAlignment(RenderText.ALIGN_RIGHT);
		setTextColor(unpack(moGuiMiniPdaSlots.priceColor));
		local greatDemand = false;
		if moGeneralSettings.foundGreatDemand > 0 and moFillTypes[k].greatDemandStation ~= nil then setTextColor(unpack(moGuiMiniPdaSlots.demandColor));greatDemand = true;end;							
		if noAmount then setTextBold(false);end;		
		renderText(posX+width-distanceDif, currentPosY, size, bestPriceTemp.. " ".. tostring(moLanguageXml:getTxt("moneysymbol")));				
		setTextAlignment(RenderText.ALIGN_LEFT);
		setTextColor(unpack(moGuiMiniPdaSlots.activeColor));		
		if greatDemand then 
			renderText(posX+width, currentPosY, size, moFillTypes[k].greatDemandStation);
			if hotSpot then setClickAreaHotSpot(self, posX+width, currentPosY, widthNext, heightDefault, moFillTypes[k].x, moFillTypes[k].z, moFillTypes[k].greatDemandStation, slot);end;
		else
			renderText(posX+width, currentPosY, size, moFillTypes[k].bestPriceStation);
			if hotSpot then setClickAreaHotSpot(self, posX+width, currentPosY, widthNext, heightDefault, moFillTypes[k].x, moFillTypes[k].z, moFillTypes[k].bestPriceStation, slot);end;
		end;				
		nextLine(true, distanceLine, true, 0.0035, width+widthNext, 0.001);
	end;
	
	moSortBestPrice = {};	
	local count = 0;
	for k,v in pairs(moFillTypes) do			
		if Fillable.fillTypeIndexToDesc[k].partOfEconomy ~= nil and Fillable.fillTypeIndexToDesc[k].partOfEconomy or moFillTypes[k].descName == "silage" then --or moFillTypes[k].descName == "wool" or moFillTypes[k].descName == "milk" or moFillTypes[k].descName == "egg" then
			if string.len(moFillTypes[k].bestPriceStation) >= 2 then
				local bestPrice = 0;
				if moFillTypes[k].greatDemandStationDescName ~= nil then
					bestPrice = moFillTypes[k].pricePerLiter*moFillTypes[k].stationPriceMulti[moFillTypes[k].greatDemandStationDescName.. " PriceMulti"]*moGeneralSettings.difficultyMultiplier*moFillTypes[k].greatDemandMultiplier*1000;
				else					
					bestPrice = moFillTypes[k].pricePerLiter*moFillTypes[k].bestPrice*moGeneralSettings.difficultyMultiplier*moFillTypes[k].greatDemandMultiplier*1000;					
				end;
				if string.find(moGeneralSettings.foundAnimals, moFillTypes[k].descName.. " ") then	
					if moFillTypes[k].greatDemandStationDescName ~= nil then
						bestPrice = moFillTypes[k].pricePerLiter/1000*moFillTypes[k].stationPriceMulti[moFillTypes[k].greatDemandStationDescName.. " PriceMulti"]*moGeneralSettings.difficultyMultiplier*moFillTypes[k].greatDemandMultiplier*1000;
					else						
						bestPrice = moFillTypes[k].pricePerLiter/1000*moFillTypes[k].bestPrice*moGeneralSettings.difficultyMultiplier*moFillTypes[k].greatDemandMultiplier*1000;						
					end;
				end;				
				--if string.find(moGeneralSettings.foundAnimals, moFillTypes[k].descName.. " ") or moFillTypes[k].descName == "beef" or moFillTypes[k].descName == "pig" or moFillTypes[k].descName == "chicken2" or moFillTypes[k].descName == "cow" or moFillTypes[k].descName == "sheep" or moFillTypes[k].descName == "chicken" then								
				--	bestPrice = moFillTypes[k].pricePerLiter/1000*moFillTypes[k].bestPrice*moGeneralSettings.difficultyMultiplier*moFillTypes[k].greatDemandMultiplier*1000;
				--end;
				--local bestPriceTemp = string.format("%.1f", Utils.getNoNil(bestPrice,0));				
				if moGuiMiniPdaSlots.values[slot].seePrice then
					count = count+1;					
					moSortBestPrice[count] = (bestPrice/1000).. ";".. k;					
				elseif moGuiMiniPdaSlots.values[slot].seeInOutFruit then				
					setInternBestPriceTotal(bestPrice, k);
				else
					setInternBestPrice(bestPrice, k);
				end;							
			end;			
		end;
	end;
	if moGuiMiniPdaSlots.values[slot].seePrice and count > 0 then
		function comp(w1,w2)
			if w1 > w2 then
				return true
			end
		end		
		table.sort(moSortBestPrice, comp);		
		for a=1, table.getn(moSortBestPrice) do
			local priceDesc = Utils.splitString(";", moSortBestPrice[a]);			
			if priceDesc ~= nil and priceDesc[1] ~= nil and priceDesc[2] ~= nil then				
				setInternBestPrice(priceDesc[1]*1000, tonumber(priceDesc[2]));
			end;
		end;
	end;
	if moGuiMiniPdaSlots.values[slot].seeInOutFruit then		
		setTextBold(true);
		local bestPriceTemp = string.format("%.3f", bestPriceTotal);
		bestPriceTemp = moGuiExtras:getMoneyFormat(bestPriceTemp);		
		setTextColor(unpack(moGuiMiniPdaSlots.activeColor));		
		renderText(posX, currentPosY, size, "Total:");
		setTextAlignment(RenderText.ALIGN_RIGHT);
		setTextColor(unpack(moGuiMiniPdaSlots.siloColor));
		renderText(posX+width-distanceDif, currentPosY, size, bestPriceTemp.. " ".. tostring(moLanguageXml:getTxt("moneysymbol")));
		setTextAlignment(false);		
		nextLine(true, distanceLine, true, 0.0035, width+widthNext, 0.001);
	end;
	----	
	moSetGetGui:setOverlay(self, moSetGetGui["designGround".. slot], posX-0.001, currentPosY+(heightSettings/2), width+widthNext, height+(heightSettings/2)); --+heightSettings	
	moGuiMiniPdaSlots.values[slot].openLastWidth = width+widthNext;
	moGuiMiniPdaSlots.values[slot].openLastHeight = height+(heightSettings/2); --+heightSettings	
	setTextColor(1, 1, 1, 1);
	setTextAlignment(false);
	setTextBold(false);	
end;

function setClickAreaHotSpot(self, posX, posY, horizontal, vertical, objX, objZ, name, slot)	
	if objX == nil or objZ == nil then return;end;
	local a = Utils.getNoNil(table.getn(moGuiMiniPdaSlots.values[slot].clickArea.slotHotSpot), 0);	
	moGuiMiniPdaSlots.values[slot].clickArea.slotHotSpot[a+1] = {posX, posX+(horizontal), posY, posY+(vertical), objX, objZ, name };
end;